﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class Bewegung : MonoBehaviour {
	public int spielSteinInt, altspielSteinInt; // 1 hochkant, 2 liegend1, 3 liegend2 
	public Vector2 alteposition, p, neuePosition; 
	GameObject auswahl;
	GameObject blocker;
	GameObject hochkant3d, liegend3d;
	SpriteRenderer[] hochkantSprites, liegendSprites;
	public GameObject vorherigerStein, hochkantStein;
	GameObject spiel2;
	public bool wand, newHighscore;
	int spielZuege =100;
	int lvl;
	bool quitRequested,pEscape, zielErreicht;
	float timeLeft = 100.0f;
	Button btHauptmenu;
	public int highscore1=0,highscore2=0,highscore3=0,score;
	// Use this for initialization


	public GameObject aktuellerStein { get; set; }

	void HighscoreBerechnen(){
				score = Mathf.RoundToInt(timeLeft) * spielZuege;

		if (lvl == 1) {
						if (score > highscore1) {
								newHighscore = true;
								highscore1 = score;
						}
				}
		else if (lvl ==2){
			if (score > highscore2) {
				newHighscore = true;
				highscore2=score;
			}
		}
		else if (lvl ==3){
			if (score > highscore3) {
				newHighscore = true;
				highscore3 = score;
			}
		}
	
		}


	void TimeLeft()
	{
				timeLeft -= Time.deltaTime;
				if (timeLeft < 0) {
						quitRequested = true;
			
			
				}


	}
	


	public GameObject hochKantStein
	{
		get { return hochkantStein; }
		set { hochkantStein = value; }
	}


	Rect _quitWindowRect = new Rect ( Screen.width/2-125, Screen.height/2-25, 250, 100 );
	
	
	void OnGUI()

	{

		if (zielErreicht == true) {
						Time.timeScale = 0;
						GUI.Window (1, _quitWindowRect, WinWindowFunction, "Gewonnen");
		}

		if (pEscape == true) {
			Time.timeScale=0;
						GUI.Window (1, _quitWindowRect, QuitWindowFunction, "Pause");
		}



		if ( quitRequested==true )
		{
			GUI.Window ( 1, _quitWindowRect, QuitWindowFunction, "Game Over!" );
		}
	}
	
	void QuitWindowFunction ( int id )
	{
		if (GUI.Button (new Rect (10, 30, 100, 30), "neu Starten")) {

						if (lvl == 1) {
								Application.LoadLevel ("Lvl1");
					
						} else if (lvl == 2) {
								Application.LoadLevel ("Lvl2");
					
						} else if (lvl == 3) {
								Application.LoadLevel ("Lvl3");
	
						}
				}
	
	
			if (GUI.Button (new Rect (120, 30, 100, 30), "Hauptmenü")) {

					Application.LoadLevel("Startmenue");
		}
				
						
					
	
	}


	void WinWindowFunction ( int id )
	{


		HighscoreBerechnen();
		if (newHighscore == true) {
			Debug.Log("hallo");
			GUI.Label (new Rect (10, 80, 200, 30), ("Score: " + score) );
				} else {
						if (lvl == 1) {
								GUI.Label (new Rect (10, 80, 200, 30), "Score: " + score + " Highscore: " + highscore1);
				GameObject.Find ("High1").GetComponent<Text> ().text = highscore1.ToString();
						} else 
			if (lvl == 2) {
								GUI.Label (new Rect (10, 80, 200, 30), "Score: " + score + " Highscore: " + highscore2);
				GameObject.Find ("High2").GetComponent<Text> ().text = highscore2.ToString();
						} else
			if (lvl == 3) {
								GUI.Label (new Rect (10, 80, 200, 30), "Score: " + score + " Highscore: " + highscore3);
				GameObject.Find ("High3").GetComponent<Text> ().text = highscore3.ToString();
						}
				}
		


		if (GUI.Button (new Rect (10, 20, 100, 30), "neu Starten")) {
			
			if (lvl == 1) {
				Application.LoadLevel ("Lvl1");
				
			} else if (lvl == 2) {
				Application.LoadLevel ("Lvl2");
				
			} else if (lvl == 3) {
				Application.LoadLevel ("Lvl3");
				
			}
		}
		
		
		if (GUI.Button (new Rect (120, 20, 100, 30), "Hauptmenü")) {
			
			Application.LoadLevel("Startmenue");
		}


		if (lvl == 1) {
						if (GUI.Button (new Rect (60, 50, 100, 30), "Level 2")) {
				
								Application.LoadLevel ("Lvl2");
						}
			}
		if (lvl == 2) {
						if (GUI.Button (new Rect (60, 50, 100, 30), "Level 3")) {
					
								Application.LoadLevel ("Lvl3");
						}
			}


		
		
	}
	
	
	public void  SetLvl (int level){
		lvl = level;
	}

	void Start () {



		newHighscore = false;
		hochkant3d = GameObject.Find ("hochkant3d");
		liegend3d = GameObject.Find ("liegend3d");

		hochkantSprites = hochkant3d.GetComponentsInChildren<SpriteRenderer> ();
		liegendSprites =liegend3d.GetComponentsInChildren<SpriteRenderer> ();

		for (int i=0; i<2; i++) {
						hochkantSprites [i].enabled = true;
			liegendSprites[i].enabled=false;
		}


		pEscape = false;
		quitRequested = false;
		hochkantStein = GameObject.Find("hochkant");
		wand = false;
		spielSteinInt = 1;
		GameObject.Find ("liegend3").GetComponent<Transform>().position = new Vector2(-50, 0);
		GameObject.Find ("liegend2").GetComponent<Transform>().position = new Vector2(-50, 0);
		
		p = GameObject.Find ("Start").GetComponent<Transform> ().position; //Startposition
		GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2(p.x,p.y); //Hochkant auf Start setzen
		aktuellerStein = GameObject.Find ("hochkant");
		neuePosition = GameObject.Find ("hochkant").GetComponent<Rigidbody2D> ().position;

		//Check, wo Start ist
		if (GameObject.Find ("Start").GetComponent<Transform> ().localPosition == new Vector3 (-1, 0, 0)) {
						lvl = 1;
				} else if (GameObject.Find ("Start").GetComponent<Transform> ().localPosition == new Vector3 (1, 3, 0)) {
						lvl = 2;
				}
		else if (GameObject.Find ("Start").GetComponent<Transform>().localPosition == new Vector3 (-8.787f , 23.41f ,0)){ //Hab das bisschen abgefuckt und kein Bock, jeden kleinen Stein zu ändern
			lvl = 3;}

		//levelspezifisch:
		if (lvl == 1) {
			spielZuege = 120 ;
			timeLeft = 120 ;
		} else if (lvl == 2) {
			spielZuege = 200 ;
			timeLeft = 120 ;
		} else if (lvl == 3) {
			spielZuege = 400 ;
			timeLeft = 180 ;
		}
		
		
	}
	
	void Update () {

		//HighscoreBerechnen ();


		if (spielSteinInt == 1) {
						for (int i=0; i<2; i++) {
								hochkantSprites [i].enabled = true;
								liegendSprites [i].enabled = false;
						}
		}

		if (spielSteinInt != 1) {
			for (int i=0; i<2; i++) {
				hochkantSprites [i].enabled = false;
				liegendSprites [i].enabled = true;
			}
		}
		

	
		
		if (spielZuege < 1) {
				quitRequested= true;
				Time.timeScale = 0;}

		GameObject.Find ("Main Camera").GetComponent<Transform> ().position = new Vector3 (aktuellerStein.GetComponent<Transform> ().position.x , aktuellerStein.GetComponent<Transform> ().position.y, aktuellerStein.GetComponent<Transform> ().position.z-10);

		if (Input.GetButtonDown ("Cancel")) {
						pEscape = !pEscape;
				if (Time.timeScale==1){
				Time.timeScale=0;}
				else{
				Time.timeScale=1;}

				} else {
						GameObject.Find ("Zuege").GetComponent<Text> ().text = spielZuege.ToString ();
						TimeLeft ();
						if (timeLeft > 0) {
								GameObject.Find ("Zeit").GetComponent<Text> ().text = Mathf.RoundToInt (timeLeft).ToString () + "s";	
						}
	

					if (hochkantStein.GetComponent<Transform>().position==GameObject.Find ("Ziel").GetComponent<Transform>().position) {
								zielErreicht=true;
					}
	
						//Die Wand wurde getroffen, da der Stein nicht da liegt wo er liegen soll
						if (!(aktuellerStein.GetComponent<Rigidbody2D> ().position == neuePosition)) {
			
								wand = true;
			
								//den alten Spielstein zurückholen
								spielSteinInt = altspielSteinInt;
			
								//den aktuellenStein, der gegen die Wand gelaufen ist verschwinden lassen
								aktuellerStein.GetComponent<Rigidbody2D> ().position = new Vector2 (-50, 0);
			
								//den vorherigen Stein auf die vorherige Position setzen
								vorherigerStein.GetComponent<Rigidbody2D> ().position = alteposition;
			
								//den vorherigen Stein zum aktuellen Stein machen
								aktuellerStein = vorherigerStein;
			
								//die Positionen anpassen
								this.PositionAnpassen (GameObject.Find ("hochkant"));
								this.PositionAnpassen (GameObject.Find ("liegend2"));
								this.PositionAnpassen (GameObject.Find ("liegend3"));
						}

						if (aktuellerStein == hochkantStein) {
								Transform[] dieliegenden = GameObject.Find ("nurLiegend").GetComponentsInChildren<Transform> ();

								for (int i=0; i<dieliegenden.Length; i++) {
										if (dieliegenden [i].position == aktuellerStein.GetComponent<Transform> ().position) {
					
												//den alten Spielstein zurückholen
												spielSteinInt = altspielSteinInt;
					
												//den aktuellenStein, der gegen die Wand gelaufen ist verschwinden lassen
												aktuellerStein.GetComponent<Rigidbody2D> ().position = new Vector2 (-50, 0);
					
												//den vorherigen Stein auf die vorherige Position setzen
												vorherigerStein.GetComponent<Rigidbody2D> ().position = alteposition;
					
												//den vorherigen Stein zum aktuellen Stein machen
												aktuellerStein = vorherigerStein;
					
												//die Positionen anpassen
												this.PositionAnpassen (GameObject.Find ("hochkant"));
												this.PositionAnpassen (GameObject.Find ("liegend2"));
												this.PositionAnpassen (GameObject.Find ("liegend3"));
					
										}
								}


						}
		
						//für den neuen Spielzug Wand wieder auf False setzen
						wand = false;
		
		
		
		
		
		
		
		
						//Den Stein bewegen
						this.Bewegen ();
				}
	}
	
	
	void Bewegen(){
		
		if (pEscape == false && spielZuege>0 && zielErreicht == false) {

			Time.timeScale=1;
					if (Input.GetButtonDown ("Left")) {
	
								spielZuege--;
			
								if (spielSteinInt == 1) {


				
										//der Int des momentanen Spielsteins speichern
										altspielSteinInt = 1;
				
										//alte Position speichern
										alteposition = GameObject.Find ("hochkant").GetComponent<Transform> ().position;
				
										//alter Spielstein verschieben
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (-50, 0);
				
										//neuen Spielstein platzieren
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (alteposition.x + (-2), alteposition.y); //nach links verschieben
				
										//neue  Position speichern
										neuePosition = GameObject.Find ("liegend2").GetComponent<Rigidbody2D> ().position;
				
										//aktuellen und vorherigen Stein speichern
										aktuellerStein = GameObject.Find ("liegend2");
										vorherigerStein = GameObject.Find ("hochkant");
				
								}
			
								if (spielSteinInt == 2) {
				
										altspielSteinInt = 2;
				
										alteposition = GameObject.Find ("liegend2").GetComponent<Transform> ().position;
				
				
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (-50, 0);
				
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (alteposition.x + (-1), alteposition.y);
				
										neuePosition = GameObject.Find ("hochkant").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("hochkant");
										vorherigerStein = GameObject.Find ("liegend2");
				
				
				
								}
								if (spielSteinInt == 3) {
										altspielSteinInt = 3;
				
										alteposition = GameObject.Find ("liegend3").GetComponent<Transform> ().position;
				
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (alteposition.x + (-1), alteposition.y); //nach links verschieben
				
										neuePosition = GameObject.Find ("liegend3").GetComponent<Transform> ().position;
				
										aktuellerStein = GameObject.Find ("liegend3");
										vorherigerStein = GameObject.Find ("liegend3");
				
								}
			
								if (spielSteinInt == 1) {
										spielSteinInt = 2;
								} else if (spielSteinInt == 2) {
										spielSteinInt = 1;
								}
			
			
						}
						if (Input.GetButtonDown ("Up")) {
								spielZuege--;
								if (spielSteinInt == 1) {
				
										altspielSteinInt = 1;
				
										alteposition = GameObject.Find ("hochkant").GetComponent<Transform> ().position;
				
				
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (-50, 0);
				
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y + 1); //nach oben verschieben
				
										neuePosition = GameObject.Find ("liegend3").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend3");
										vorherigerStein = GameObject.Find ("hochkant");
				
								}
			
								if (spielSteinInt == 2) {
				
										altspielSteinInt = 2;
				
										alteposition = GameObject.Find ("liegend2").GetComponent<Transform> ().position;
				
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y + 1); //nach oben verschieben
				
										neuePosition = GameObject.Find ("liegend2").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend2");
										vorherigerStein = GameObject.Find ("liegend2");
				
				
								}
			
								if (spielSteinInt == 3) {
				
										altspielSteinInt = 3;
				
										alteposition = GameObject.Find ("liegend3").GetComponent<Transform> ().position;
				
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (-50, 0);
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y + 2); //nach oben verschieben
				
										neuePosition = GameObject.Find ("hochkant").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("hochkant");
										vorherigerStein = GameObject.Find ("liegend3");
				
				
								}
			
								if (spielSteinInt == 1 && wand == false) {
										spielSteinInt = 3;
								} else if (spielSteinInt == 3 && wand == false) {
										spielSteinInt = 1;
								}
						}
						if (Input.GetButtonDown ("Down")) {				
								spielZuege--;
								if (spielSteinInt == 1) {
				
										altspielSteinInt = 1;
				
										alteposition = GameObject.Find ("hochkant").GetComponent<Transform> ().position;
				
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (-50, 0);
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y + (-2)); //nach unten verschieben
				
										neuePosition = GameObject.Find ("liegend3").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend3");
										vorherigerStein = GameObject.Find ("hochkant");
				
				
								}
			
								if (spielSteinInt == 2) {
				
										altspielSteinInt = 2;
				
										alteposition = GameObject.Find ("liegend2").GetComponent<Transform> ().position;
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y - 1); //nach unten verschieben
				
										neuePosition = GameObject.Find ("liegend2").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend2");
										vorherigerStein = GameObject.Find ("liegend2");
				
				
								}
			
								if (spielSteinInt == 3) {
				
										altspielSteinInt = 3;
				
										alteposition = GameObject.Find ("liegend3").GetComponent<Transform> ().position;
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (-50, 0);
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (alteposition.x, alteposition.y + (-1)); //nach unten verschieben
				
										neuePosition = GameObject.Find ("hochkant").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("hochkant");
										vorherigerStein = GameObject.Find ("liegend3");
				
				
								}
								if (spielSteinInt == 1 && wand == false) {
										spielSteinInt = 3;
								} else if (spielSteinInt == 3 && wand == false) {
										spielSteinInt = 1;
								}
						}
						if (Input.GetButtonDown ("Right")) {	
								spielZuege--;
								if (spielSteinInt == 1) {
				
										altspielSteinInt = 1;
				
										alteposition = GameObject.Find ("hochkant").GetComponent<Transform> ().position;
				
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (-50, 0);
				
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (alteposition.x + 1, alteposition.y); //nach rechts verschieben
				
										neuePosition = GameObject.Find ("liegend2").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend2");
										vorherigerStein = GameObject.Find ("hochkant");
				
				
								}
			
								if (spielSteinInt == 2) {
				
										altspielSteinInt = 2;
				
										alteposition = GameObject.Find ("liegend2").GetComponent<Transform> ().position;
										//vorherigerStein=GameObject.Find ("liegend2");
										GameObject.Find ("liegend2").GetComponent<Transform> ().position = new Vector2 (-50, 0);
				
										GameObject.Find ("hochkant").GetComponent<Transform> ().position = new Vector2 (alteposition.x + 2, alteposition.y);  //nach rechts verschieben
				
										neuePosition = GameObject.Find ("hochkant").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("hochkant");
										vorherigerStein = GameObject.Find ("liegend2");
				
				
								}
			
								if (spielSteinInt == 3) {
				
										altspielSteinInt = 3;
				
										alteposition = GameObject.Find ("liegend3").GetComponent<Transform> ().position;
										//vorherigerStein=GameObject.Find ("liegend3");
				
										GameObject.Find ("liegend3").GetComponent<Transform> ().position = new Vector2 (alteposition.x + 1, alteposition.y); //nach rechts verschieben
				
										neuePosition = GameObject.Find ("liegend3").GetComponent<Rigidbody2D> ().position;
				
										aktuellerStein = GameObject.Find ("liegend3");
										vorherigerStein = GameObject.Find ("liegend3");
				
				
								}	
								if (spielSteinInt == 1 && wand == false) {
										spielSteinInt = 2;
								} else if (spielSteinInt == 2 && wand == false) {
										spielSteinInt = 1;
								}					
			
			
						}
		
		
				}
		
	}
	
	
	void PositionAnpassen(GameObject anzupassen){
		int xAnpassen=Mathf.RoundToInt (anzupassen.GetComponent<Rigidbody2D> ().position.x);
		int yAnpassen=Mathf.RoundToInt (anzupassen.GetComponent<Rigidbody2D> ().position.y);
		
		anzupassen.GetComponent<Transform> ().position = new Vector2 (xAnpassen, yAnpassen);
		
	}




	
	
	
}










